/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/

package org.emftext.sdk.concretesyntax.resource.cs.grammar;

/**
 * This class provides the follow sets for all terminals of the grammar. These
 * sets are used during code completion.
 */
public class CsFollowSetProvider {
	
	public final static org.emftext.sdk.concretesyntax.resource.cs.ICsExpectedElement TERMINALS[] = new org.emftext.sdk.concretesyntax.resource.cs.ICsExpectedElement[122];
	
	public final static org.eclipse.emf.ecore.EStructuralFeature[] FEATURES = new org.eclipse.emf.ecore.EStructuralFeature[10];
	
	public final static org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] LINKS = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[307];
	
	public final static org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] EMPTY_LINK_ARRAY = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[0];
	
	public static void initializeTerminals0() {
		TERMINALS[0] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedCsString(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_24_0_0_0);
		TERMINALS[1] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedBooleanTerminal(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_0_0_0_1);
		TERMINALS[2] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedCsString(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_0_0_0_2);
		TERMINALS[3] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedStructuralFeature(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_0_0_0_4);
		TERMINALS[4] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedCsString(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_0_0_0_6);
		TERMINALS[5] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedStructuralFeature(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_0_0_0_8);
		TERMINALS[6] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedStructuralFeature(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_0_0_0_9_0_0_1);
		TERMINALS[7] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedCsString(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_0_0_0_11_0_0_0);
		TERMINALS[8] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedCsString(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_0_0_0_12_0_0_2);
		TERMINALS[9] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedCsString(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_0_0_0_13_0_0_2);
		TERMINALS[10] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedCsString(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_0_0_0_14_0_0_2);
		TERMINALS[11] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedCsString(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_0_0_0_15_0_0_2);
		TERMINALS[12] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedCsString(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_0_0_0_18);
		TERMINALS[13] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedStructuralFeature(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_0_0_0_11_0_0_2_0_0_0);
		TERMINALS[14] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedCsString(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_0_0_0_11_0_0_3_0_0_0);
		TERMINALS[15] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedStructuralFeature(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_0_0_0_11_0_0_3_0_0_1_0_0_0);
		TERMINALS[16] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedCsString(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_0_0_0_12_0_0_4);
		TERMINALS[17] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedStructuralFeature(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_1_0_0_1);
		TERMINALS[18] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedCsString(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_0_0_0_12_0_0_7);
		TERMINALS[19] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedCsString(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_0_0_0_13_0_0_4);
		TERMINALS[20] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedStructuralFeature(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_2_0_0_0);
		TERMINALS[21] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedCsString(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_0_0_0_13_0_0_7);
		TERMINALS[22] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedCsString(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_0_0_0_13_0_0_5_0_0_2);
		TERMINALS[23] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedCsString(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_0_0_0_14_0_0_4);
		TERMINALS[24] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedCsString(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_17_0_0_1);
		TERMINALS[25] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedCsString(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_18_0_0_1);
		TERMINALS[26] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedCsString(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_19_0_0_0);
		TERMINALS[27] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedCsString(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_20_0_0_0);
		TERMINALS[28] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedCsString(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_0_0_0_14_0_0_7);
		TERMINALS[29] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedCsString(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_0_0_0_14_0_0_5_0_0_2);
		TERMINALS[30] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedCsString(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_0_0_0_15_0_0_4);
		TERMINALS[31] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedStructuralFeature(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_23_0_0_0);
		TERMINALS[32] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedCsString(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_0_0_0_15_0_0_7);
		TERMINALS[33] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedCsString(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_0_0_0_20);
		TERMINALS[34] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedStructuralFeature(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_3_0_0_1);
		TERMINALS[35] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedCsString(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_0_0_0_23);
		TERMINALS[36] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedCsString(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_1_0_0_2);
		TERMINALS[37] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedStructuralFeature(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_1_0_0_3);
		TERMINALS[38] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedStructuralFeature(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_1_0_0_4_0_0_1);
		TERMINALS[39] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedCsString(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_1_0_0_5_0_0_1);
		TERMINALS[40] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedCsString(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_1_0_0_5_0_0_3);
		TERMINALS[41] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedStructuralFeature(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_1_0_0_5_0_0_5);
		TERMINALS[42] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedStructuralFeature(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_1_0_0_5_0_0_6_0_0_1);
		TERMINALS[43] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedCsString(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_2_0_0_2);
		TERMINALS[44] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedStructuralFeature(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_2_0_0_4);
		TERMINALS[45] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedCsString(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_3_0_0_3);
		TERMINALS[46] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedStructuralFeature(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_6_0_0_0);
		TERMINALS[47] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedStructuralFeature(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_7_0_0_0);
		TERMINALS[48] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedStructuralFeature(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_8_0_0_0);
		TERMINALS[49] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedStructuralFeature(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_9_0_0_0);
		TERMINALS[50] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedStructuralFeature(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_10_0_0_0);
		TERMINALS[51] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedStructuralFeature(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_11_0_0_0);
		TERMINALS[52] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedStructuralFeature(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_13_0_0_0);
		TERMINALS[53] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedCsString(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_14_0_0_0);
		TERMINALS[54] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedStructuralFeature(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_15_0_0_0);
		TERMINALS[55] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedStructuralFeature(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_16_0_0_0);
		TERMINALS[56] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedCsString(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_3_0_0_6);
		TERMINALS[57] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedCsString(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_5_0_0_1_0_0_1);
		TERMINALS[58] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedCsString(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_14_0_0_2);
		TERMINALS[59] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedCsString(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_7_0_0_1);
		TERMINALS[60] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedStructuralFeature(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_7_0_0_2);
		TERMINALS[61] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedCsString(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_7_0_0_3);
		TERMINALS[62] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedEnumerationTerminal(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_7_0_0_4);
		TERMINALS[63] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedCsString(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_8_0_0_1);
		TERMINALS[64] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedCsString(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_8_0_0_2);
		TERMINALS[65] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedEnumerationTerminal(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_8_0_0_3);
		TERMINALS[66] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedCsString(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_9_0_0_1);
		TERMINALS[67] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedStructuralFeature(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_9_0_0_2);
		TERMINALS[68] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedCsString(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_9_0_0_3);
		TERMINALS[69] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedStructuralFeature(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_9_0_0_4);
		TERMINALS[70] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedCsString(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_9_0_0_5_0_0_0);
		TERMINALS[71] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedCsString(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_9_0_0_6);
		TERMINALS[72] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedStructuralFeature(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_9_0_0_5_0_0_1);
		TERMINALS[73] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedEnumerationTerminal(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_9_0_0_7);
		TERMINALS[74] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedCsString(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_10_0_0_1);
		TERMINALS[75] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedStructuralFeature(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_10_0_0_2);
		TERMINALS[76] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedCsString(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_10_0_0_4);
		TERMINALS[77] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedStructuralFeature(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_10_0_0_6);
		TERMINALS[78] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedCsString(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_10_0_0_7);
		TERMINALS[79] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedEnumerationTerminal(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_10_0_0_8);
		TERMINALS[80] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedCsString(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_11_0_0_1);
		TERMINALS[81] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedStructuralFeature(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_12_0_0_0);
		TERMINALS[82] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedCsString(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_11_0_0_3_0_0_0);
		TERMINALS[83] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedCsString(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_11_0_0_4);
		TERMINALS[84] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedEnumerationTerminal(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_11_0_0_5);
		TERMINALS[85] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedCsString(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_12_0_0_1);
		TERMINALS[86] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedStructuralFeature(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_12_0_0_2);
		TERMINALS[87] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedCsString(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_13_0_0_1_0_0_0);
		TERMINALS[88] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedEnumerationTerminal(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_13_0_0_2);
		TERMINALS[89] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedStructuralFeature(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_13_0_0_1_0_0_1);
		TERMINALS[90] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedCsString(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_13_0_0_1_0_0_2_0_0_0);
		TERMINALS[91] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedStructuralFeature(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_13_0_0_1_0_0_2_0_0_1);
		TERMINALS[92] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedEnumerationTerminal(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_14_0_0_3);
		TERMINALS[93] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedStructuralFeature(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_17_0_0_3);
		TERMINALS[94] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedCsString(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_17_0_0_4);
		TERMINALS[95] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedStructuralFeature(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_17_0_0_5);
		TERMINALS[96] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedStructuralFeature(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_21_0_0_0);
		TERMINALS[97] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedStructuralFeature(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_22_0_0_0);
		TERMINALS[98] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedCsString(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_17_0_0_8_0_0_1);
		TERMINALS[99] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedStructuralFeature(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_18_0_0_3);
		TERMINALS[100] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedCsString(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_18_0_0_6_0_0_1);
		TERMINALS[101] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedCsString(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_18_0_0_7_0_0_1);
		TERMINALS[102] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedCsString(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_18_0_0_7_0_0_3);
		TERMINALS[103] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedStructuralFeature(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_18_0_0_7_0_0_5);
		TERMINALS[104] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedCsString(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_19_0_0_2);
		TERMINALS[105] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedStructuralFeature(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_19_0_0_4);
		TERMINALS[106] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedCsString(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_19_0_0_7_0_0_1);
		TERMINALS[107] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedStructuralFeature(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_20_0_0_2);
		TERMINALS[108] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedCsString(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_23_0_0_1_0_0_0);
		TERMINALS[109] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedCsString(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_23_0_0_3);
		TERMINALS[110] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedStructuralFeature(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_23_0_0_1_0_0_2);
		TERMINALS[111] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedStructuralFeature(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_23_0_0_5);
		TERMINALS[112] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedCsString(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_23_0_0_6_0_0_0);
		TERMINALS[113] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedCsString(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_23_0_0_7);
		TERMINALS[114] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedStructuralFeature(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_23_0_0_6_0_0_2);
		TERMINALS[115] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedStructuralFeature(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_24_0_0_1);
		TERMINALS[116] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedCsString(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_24_0_0_2_0_0_0);
		TERMINALS[117] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedStructuralFeature(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_25_0_0_0);
		TERMINALS[118] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedCsString(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_24_0_0_2_0_0_2_0_0_0);
		TERMINALS[119] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedCsString(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_24_0_0_2_0_0_3);
		TERMINALS[120] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedCsString(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_25_0_0_1_0_0_0);
		TERMINALS[121] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsExpectedStructuralFeature(org.emftext.sdk.concretesyntax.resource.cs.grammar.CsGrammarInformationProvider.CS_25_0_0_1_0_0_1);
	}
	
	public static void initializeTerminals() {
		initializeTerminals0();
	}
	
	public static void initializeFeatures0() {
		FEATURES[0] = org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getAnnotable().getEStructuralFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.ANNOTABLE__ANNOTATIONS);
		FEATURES[1] = org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getConcreteSyntax().getEStructuralFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.CONCRETE_SYNTAX__IMPORTS);
		FEATURES[2] = org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getConcreteSyntax().getEStructuralFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.CONCRETE_SYNTAX__OPTIONS);
		FEATURES[3] = org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getConcreteSyntax().getEStructuralFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.CONCRETE_SYNTAX__TOKENS);
		FEATURES[4] = org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getConcreteSyntax().getEStructuralFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.CONCRETE_SYNTAX__TOKEN_STYLES);
		FEATURES[5] = org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getConcreteSyntax().getEStructuralFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.CONCRETE_SYNTAX__RULES);
		FEATURES[6] = org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getSyntaxElement().getEStructuralFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.SYNTAX_ELEMENT__CHILDREN);
		FEATURES[7] = org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getEnumTerminal().getEStructuralFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.ENUM_TERMINAL__LITERALS);
		FEATURES[8] = org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getRegexComposite().getEStructuralFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.REGEX_COMPOSITE__REGEX_PARTS);
		FEATURES[9] = org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getAnnotation().getEStructuralFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.ANNOTATION__PARAMETERS);
	}
	
	public static void initializeFeatures() {
		initializeFeatures0();
	}
	
	public static void initializeLinks0() {
		LINKS[0] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getAnnotation(), FEATURES[0]);
		LINKS[1] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getAnnotation(), FEATURES[0]);
		LINKS[2] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getAnnotation(), FEATURES[0]);
		LINKS[3] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getAnnotation(), FEATURES[0]);
		LINKS[4] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getImport(), FEATURES[1]);
		LINKS[5] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getImport(), FEATURES[1]);
		LINKS[6] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getAnnotation(), FEATURES[0]);
		LINKS[7] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getImport(), FEATURES[1]);
		LINKS[8] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getImport(), FEATURES[1]);
		LINKS[9] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getAnnotation(), FEATURES[0]);
		LINKS[10] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getImport(), FEATURES[1]);
		LINKS[11] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getImport(), FEATURES[1]);
		LINKS[12] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getOption(), FEATURES[2]);
		LINKS[13] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getOption(), FEATURES[2]);
		LINKS[14] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getOption(), FEATURES[2]);
		LINKS[15] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getAnnotation(), FEATURES[0]);
		LINKS[16] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getTokenRedefinition(), FEATURES[3]);
		LINKS[17] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getTokenRedefinition(), FEATURES[3]);
		LINKS[18] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getNormalTokenDefinition(), FEATURES[3]);
		LINKS[19] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getPartialTokenDefinition(), FEATURES[3]);
		LINKS[20] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getTokenPriorityDirective(), FEATURES[3]);
		LINKS[21] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getAnnotation(), FEATURES[0]);
		LINKS[22] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getTokenRedefinition(), FEATURES[3]);
		LINKS[23] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getTokenRedefinition(), FEATURES[3]);
		LINKS[24] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getNormalTokenDefinition(), FEATURES[3]);
		LINKS[25] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getPartialTokenDefinition(), FEATURES[3]);
		LINKS[26] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getTokenPriorityDirective(), FEATURES[3]);
		LINKS[27] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getAnnotation(), FEATURES[0]);
		LINKS[28] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getTokenRedefinition(), FEATURES[3]);
		LINKS[29] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getTokenRedefinition(), FEATURES[3]);
		LINKS[30] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getNormalTokenDefinition(), FEATURES[3]);
		LINKS[31] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getPartialTokenDefinition(), FEATURES[3]);
		LINKS[32] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getTokenPriorityDirective(), FEATURES[3]);
		LINKS[33] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getTokenStyle(), FEATURES[4]);
		LINKS[34] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getTokenStyle(), FEATURES[4]);
		LINKS[35] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getTokenStyle(), FEATURES[4]);
		LINKS[36] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getAnnotation(), FEATURES[0]);
		LINKS[37] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getRule(), FEATURES[5]);
		LINKS[38] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getRule(), FEATURES[5]);
		LINKS[39] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getAnnotation(), FEATURES[0]);
		LINKS[40] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getRule(), FEATURES[5]);
		LINKS[41] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getRule(), FEATURES[5]);
		LINKS[42] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getAnnotation(), FEATURES[0]);
		LINKS[43] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getRule(), FEATURES[5]);
		LINKS[44] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getRule(), FEATURES[5]);
		LINKS[45] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getAnnotation(), FEATURES[0]);
		LINKS[46] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getAnnotation(), FEATURES[0]);
		LINKS[47] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getAnnotation(), FEATURES[0]);
		LINKS[48] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getImport(), FEATURES[1]);
		LINKS[49] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getImport(), FEATURES[1]);
		LINKS[50] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getAnnotation(), FEATURES[0]);
		LINKS[51] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getImport(), FEATURES[1]);
		LINKS[52] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getImport(), FEATURES[1]);
		LINKS[53] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getAnnotation(), FEATURES[0]);
		LINKS[54] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getImport(), FEATURES[1]);
		LINKS[55] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getImport(), FEATURES[1]);
		LINKS[56] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getAnnotation(), FEATURES[0]);
		LINKS[57] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getImport(), FEATURES[1]);
		LINKS[58] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getImport(), FEATURES[1]);
		LINKS[59] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getAnnotation(), FEATURES[0]);
		LINKS[60] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getImport(), FEATURES[1]);
		LINKS[61] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getImport(), FEATURES[1]);
		LINKS[62] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getAnnotation(), FEATURES[0]);
		LINKS[63] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getImport(), FEATURES[1]);
		LINKS[64] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getImport(), FEATURES[1]);
		LINKS[65] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getAnnotation(), FEATURES[0]);
		LINKS[66] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getImport(), FEATURES[1]);
		LINKS[67] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getImport(), FEATURES[1]);
		LINKS[68] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getAnnotation(), FEATURES[0]);
		LINKS[69] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getAnnotation(), FEATURES[0]);
		LINKS[70] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getCsString(), FEATURES[6]);
		LINKS[71] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getSequence(), FEATURES[6]);
		LINKS[72] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getChoice(), FEATURES[6]);
		LINKS[73] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getPlaceholderUsingSpecifiedToken(), FEATURES[6]);
		LINKS[74] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getSequence(), FEATURES[6]);
		LINKS[75] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getChoice(), FEATURES[6]);
		LINKS[76] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getPlaceholderUsingDefaultToken(), FEATURES[6]);
		LINKS[77] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getSequence(), FEATURES[6]);
		LINKS[78] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getChoice(), FEATURES[6]);
		LINKS[79] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getPlaceholderInQuotes(), FEATURES[6]);
		LINKS[80] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getSequence(), FEATURES[6]);
		LINKS[81] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getChoice(), FEATURES[6]);
		LINKS[82] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getBooleanTerminal(), FEATURES[6]);
		LINKS[83] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getSequence(), FEATURES[6]);
		LINKS[84] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getChoice(), FEATURES[6]);
		LINKS[85] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getEnumTerminal(), FEATURES[6]);
		LINKS[86] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getSequence(), FEATURES[6]);
		LINKS[87] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getChoice(), FEATURES[6]);
		LINKS[88] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getContainment(), FEATURES[6]);
		LINKS[89] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getSequence(), FEATURES[6]);
		LINKS[90] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getChoice(), FEATURES[6]);
		LINKS[91] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getCompoundDefinition(), FEATURES[6]);
		LINKS[92] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getSequence(), FEATURES[6]);
		LINKS[93] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getChoice(), FEATURES[6]);
		LINKS[94] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getWhiteSpaces(), FEATURES[6]);
		LINKS[95] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getSequence(), FEATURES[6]);
		LINKS[96] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getChoice(), FEATURES[6]);
		LINKS[97] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getLineBreak(), FEATURES[6]);
		LINKS[98] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getSequence(), FEATURES[6]);
		LINKS[99] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getChoice(), FEATURES[6]);
		LINKS[100] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getAnnotation(), FEATURES[0]);
		LINKS[101] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getRule(), FEATURES[5]);
		LINKS[102] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getRule(), FEATURES[5]);
		LINKS[103] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getCsString(), FEATURES[6]);
		LINKS[104] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getPlaceholderUsingSpecifiedToken(), FEATURES[6]);
		LINKS[105] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getPlaceholderUsingDefaultToken(), FEATURES[6]);
		LINKS[106] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getPlaceholderInQuotes(), FEATURES[6]);
		LINKS[107] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getBooleanTerminal(), FEATURES[6]);
		LINKS[108] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getEnumTerminal(), FEATURES[6]);
		LINKS[109] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getContainment(), FEATURES[6]);
		LINKS[110] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getCompoundDefinition(), FEATURES[6]);
		LINKS[111] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getWhiteSpaces(), FEATURES[6]);
		LINKS[112] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getLineBreak(), FEATURES[6]);
		LINKS[113] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getCsString(), FEATURES[6]);
		LINKS[114] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getPlaceholderUsingSpecifiedToken(), FEATURES[6]);
		LINKS[115] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getPlaceholderUsingDefaultToken(), FEATURES[6]);
		LINKS[116] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getPlaceholderInQuotes(), FEATURES[6]);
		LINKS[117] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getBooleanTerminal(), FEATURES[6]);
		LINKS[118] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getEnumTerminal(), FEATURES[6]);
		LINKS[119] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getContainment(), FEATURES[6]);
		LINKS[120] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getCompoundDefinition(), FEATURES[6]);
		LINKS[121] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getWhiteSpaces(), FEATURES[6]);
		LINKS[122] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getLineBreak(), FEATURES[6]);
		LINKS[123] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getCsString(), FEATURES[6]);
		LINKS[124] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getPlaceholderUsingSpecifiedToken(), FEATURES[6]);
		LINKS[125] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getPlaceholderUsingDefaultToken(), FEATURES[6]);
		LINKS[126] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getPlaceholderInQuotes(), FEATURES[6]);
		LINKS[127] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getBooleanTerminal(), FEATURES[6]);
		LINKS[128] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getEnumTerminal(), FEATURES[6]);
		LINKS[129] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getContainment(), FEATURES[6]);
		LINKS[130] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getCompoundDefinition(), FEATURES[6]);
		LINKS[131] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getWhiteSpaces(), FEATURES[6]);
		LINKS[132] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getLineBreak(), FEATURES[6]);
		LINKS[133] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getCsString(), FEATURES[6]);
		LINKS[134] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getSequence(), FEATURES[6]);
		LINKS[135] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getPlaceholderUsingSpecifiedToken(), FEATURES[6]);
		LINKS[136] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getSequence(), FEATURES[6]);
		LINKS[137] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getPlaceholderUsingDefaultToken(), FEATURES[6]);
		LINKS[138] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getSequence(), FEATURES[6]);
		LINKS[139] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getPlaceholderInQuotes(), FEATURES[6]);
		LINKS[140] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getSequence(), FEATURES[6]);
		LINKS[141] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getBooleanTerminal(), FEATURES[6]);
		LINKS[142] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getSequence(), FEATURES[6]);
		LINKS[143] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getEnumTerminal(), FEATURES[6]);
		LINKS[144] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getSequence(), FEATURES[6]);
		LINKS[145] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getContainment(), FEATURES[6]);
		LINKS[146] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getSequence(), FEATURES[6]);
		LINKS[147] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getCompoundDefinition(), FEATURES[6]);
		LINKS[148] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getSequence(), FEATURES[6]);
		LINKS[149] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getWhiteSpaces(), FEATURES[6]);
		LINKS[150] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getSequence(), FEATURES[6]);
		LINKS[151] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getLineBreak(), FEATURES[6]);
		LINKS[152] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getSequence(), FEATURES[6]);
		LINKS[153] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getCsString(), FEATURES[6]);
		LINKS[154] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getPlaceholderUsingSpecifiedToken(), FEATURES[6]);
		LINKS[155] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getPlaceholderUsingDefaultToken(), FEATURES[6]);
		LINKS[156] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getPlaceholderInQuotes(), FEATURES[6]);
		LINKS[157] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getBooleanTerminal(), FEATURES[6]);
		LINKS[158] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getEnumTerminal(), FEATURES[6]);
		LINKS[159] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getContainment(), FEATURES[6]);
		LINKS[160] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getCompoundDefinition(), FEATURES[6]);
		LINKS[161] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getWhiteSpaces(), FEATURES[6]);
		LINKS[162] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getLineBreak(), FEATURES[6]);
		LINKS[163] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getCsString(), FEATURES[6]);
		LINKS[164] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getPlaceholderUsingSpecifiedToken(), FEATURES[6]);
		LINKS[165] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getPlaceholderUsingDefaultToken(), FEATURES[6]);
		LINKS[166] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getPlaceholderInQuotes(), FEATURES[6]);
		LINKS[167] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getBooleanTerminal(), FEATURES[6]);
		LINKS[168] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getEnumTerminal(), FEATURES[6]);
		LINKS[169] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getContainment(), FEATURES[6]);
		LINKS[170] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getCompoundDefinition(), FEATURES[6]);
		LINKS[171] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getWhiteSpaces(), FEATURES[6]);
		LINKS[172] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getLineBreak(), FEATURES[6]);
		LINKS[173] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getCsString(), FEATURES[6]);
		LINKS[174] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getPlaceholderUsingSpecifiedToken(), FEATURES[6]);
		LINKS[175] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getPlaceholderUsingDefaultToken(), FEATURES[6]);
		LINKS[176] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getPlaceholderInQuotes(), FEATURES[6]);
		LINKS[177] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getBooleanTerminal(), FEATURES[6]);
		LINKS[178] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getEnumTerminal(), FEATURES[6]);
		LINKS[179] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getContainment(), FEATURES[6]);
		LINKS[180] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getCompoundDefinition(), FEATURES[6]);
		LINKS[181] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getWhiteSpaces(), FEATURES[6]);
		LINKS[182] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getLineBreak(), FEATURES[6]);
		LINKS[183] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getCsString(), FEATURES[6]);
		LINKS[184] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getPlaceholderUsingSpecifiedToken(), FEATURES[6]);
		LINKS[185] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getPlaceholderUsingDefaultToken(), FEATURES[6]);
		LINKS[186] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getPlaceholderInQuotes(), FEATURES[6]);
		LINKS[187] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getBooleanTerminal(), FEATURES[6]);
		LINKS[188] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getEnumTerminal(), FEATURES[6]);
		LINKS[189] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getContainment(), FEATURES[6]);
		LINKS[190] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getCompoundDefinition(), FEATURES[6]);
		LINKS[191] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getWhiteSpaces(), FEATURES[6]);
		LINKS[192] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getLineBreak(), FEATURES[6]);
		LINKS[193] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getCsString(), FEATURES[6]);
		LINKS[194] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getPlaceholderUsingSpecifiedToken(), FEATURES[6]);
		LINKS[195] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getPlaceholderUsingDefaultToken(), FEATURES[6]);
		LINKS[196] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getPlaceholderInQuotes(), FEATURES[6]);
		LINKS[197] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getBooleanTerminal(), FEATURES[6]);
		LINKS[198] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getEnumTerminal(), FEATURES[6]);
		LINKS[199] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getContainment(), FEATURES[6]);
		LINKS[200] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getCompoundDefinition(), FEATURES[6]);
		LINKS[201] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getWhiteSpaces(), FEATURES[6]);
		LINKS[202] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getLineBreak(), FEATURES[6]);
		LINKS[203] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getEnumLiteralTerminal(), FEATURES[7]);
		LINKS[204] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getEnumLiteralTerminal(), FEATURES[7]);
		LINKS[205] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getCsString(), FEATURES[6]);
		LINKS[206] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getPlaceholderUsingSpecifiedToken(), FEATURES[6]);
		LINKS[207] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getPlaceholderUsingDefaultToken(), FEATURES[6]);
		LINKS[208] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getPlaceholderInQuotes(), FEATURES[6]);
		LINKS[209] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getBooleanTerminal(), FEATURES[6]);
		LINKS[210] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getEnumTerminal(), FEATURES[6]);
		LINKS[211] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getContainment(), FEATURES[6]);
		LINKS[212] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getCompoundDefinition(), FEATURES[6]);
		LINKS[213] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getWhiteSpaces(), FEATURES[6]);
		LINKS[214] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getLineBreak(), FEATURES[6]);
		LINKS[215] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getCsString(), FEATURES[6]);
		LINKS[216] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getPlaceholderUsingSpecifiedToken(), FEATURES[6]);
		LINKS[217] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getPlaceholderUsingDefaultToken(), FEATURES[6]);
		LINKS[218] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getPlaceholderInQuotes(), FEATURES[6]);
		LINKS[219] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getBooleanTerminal(), FEATURES[6]);
		LINKS[220] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getEnumTerminal(), FEATURES[6]);
		LINKS[221] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getContainment(), FEATURES[6]);
		LINKS[222] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getCompoundDefinition(), FEATURES[6]);
		LINKS[223] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getWhiteSpaces(), FEATURES[6]);
		LINKS[224] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getLineBreak(), FEATURES[6]);
		LINKS[225] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getCsString(), FEATURES[6]);
		LINKS[226] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getSequence(), FEATURES[6]);
		LINKS[227] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getChoice(), FEATURES[6]);
		LINKS[228] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getPlaceholderUsingSpecifiedToken(), FEATURES[6]);
		LINKS[229] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getSequence(), FEATURES[6]);
		LINKS[230] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getChoice(), FEATURES[6]);
		LINKS[231] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getPlaceholderUsingDefaultToken(), FEATURES[6]);
		LINKS[232] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getSequence(), FEATURES[6]);
		LINKS[233] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getChoice(), FEATURES[6]);
		LINKS[234] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getPlaceholderInQuotes(), FEATURES[6]);
		LINKS[235] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getSequence(), FEATURES[6]);
		LINKS[236] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getChoice(), FEATURES[6]);
		LINKS[237] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getBooleanTerminal(), FEATURES[6]);
		LINKS[238] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getSequence(), FEATURES[6]);
		LINKS[239] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getChoice(), FEATURES[6]);
		LINKS[240] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getEnumTerminal(), FEATURES[6]);
		LINKS[241] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getSequence(), FEATURES[6]);
		LINKS[242] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getChoice(), FEATURES[6]);
		LINKS[243] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getContainment(), FEATURES[6]);
		LINKS[244] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getSequence(), FEATURES[6]);
		LINKS[245] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getChoice(), FEATURES[6]);
		LINKS[246] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getCompoundDefinition(), FEATURES[6]);
		LINKS[247] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getSequence(), FEATURES[6]);
		LINKS[248] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getChoice(), FEATURES[6]);
		LINKS[249] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getWhiteSpaces(), FEATURES[6]);
		LINKS[250] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getSequence(), FEATURES[6]);
		LINKS[251] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getChoice(), FEATURES[6]);
		LINKS[252] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getLineBreak(), FEATURES[6]);
		LINKS[253] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getSequence(), FEATURES[6]);
		LINKS[254] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getChoice(), FEATURES[6]);
		LINKS[255] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getCsString(), FEATURES[6]);
		LINKS[256] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getPlaceholderUsingSpecifiedToken(), FEATURES[6]);
		LINKS[257] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getPlaceholderUsingDefaultToken(), FEATURES[6]);
		LINKS[258] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getPlaceholderInQuotes(), FEATURES[6]);
		LINKS[259] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getBooleanTerminal(), FEATURES[6]);
		LINKS[260] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getEnumTerminal(), FEATURES[6]);
		LINKS[261] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getContainment(), FEATURES[6]);
		LINKS[262] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getCompoundDefinition(), FEATURES[6]);
		LINKS[263] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getWhiteSpaces(), FEATURES[6]);
		LINKS[264] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getLineBreak(), FEATURES[6]);
		LINKS[265] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getCsString(), FEATURES[6]);
		LINKS[266] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getPlaceholderUsingSpecifiedToken(), FEATURES[6]);
		LINKS[267] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getPlaceholderUsingDefaultToken(), FEATURES[6]);
		LINKS[268] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getPlaceholderInQuotes(), FEATURES[6]);
		LINKS[269] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getBooleanTerminal(), FEATURES[6]);
		LINKS[270] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getEnumTerminal(), FEATURES[6]);
		LINKS[271] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getContainment(), FEATURES[6]);
		LINKS[272] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getCompoundDefinition(), FEATURES[6]);
		LINKS[273] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getWhiteSpaces(), FEATURES[6]);
		LINKS[274] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getLineBreak(), FEATURES[6]);
		LINKS[275] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getCsString(), FEATURES[6]);
		LINKS[276] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getPlaceholderUsingSpecifiedToken(), FEATURES[6]);
		LINKS[277] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getPlaceholderUsingDefaultToken(), FEATURES[6]);
		LINKS[278] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getPlaceholderInQuotes(), FEATURES[6]);
		LINKS[279] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getBooleanTerminal(), FEATURES[6]);
		LINKS[280] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getEnumTerminal(), FEATURES[6]);
		LINKS[281] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getContainment(), FEATURES[6]);
		LINKS[282] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getCompoundDefinition(), FEATURES[6]);
		LINKS[283] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getWhiteSpaces(), FEATURES[6]);
		LINKS[284] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getLineBreak(), FEATURES[6]);
		LINKS[285] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getAnnotation(), FEATURES[0]);
		LINKS[286] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getAnnotation(), FEATURES[0]);
		LINKS[287] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getAtomicRegex(), FEATURES[8]);
		LINKS[288] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getRegexReference(), FEATURES[8]);
		LINKS[289] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getAtomicRegex(), FEATURES[8]);
		LINKS[290] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getRegexReference(), FEATURES[8]);
		LINKS[291] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getAnnotation(), FEATURES[0]);
		LINKS[292] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getAnnotation(), FEATURES[0]);
		LINKS[293] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getAtomicRegex(), FEATURES[8]);
		LINKS[294] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getRegexReference(), FEATURES[8]);
		LINKS[295] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getAtomicRegex(), FEATURES[8]);
		LINKS[296] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getRegexReference(), FEATURES[8]);
		LINKS[297] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getAtomicRegex(), FEATURES[8]);
		LINKS[298] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getRegexReference(), FEATURES[8]);
		LINKS[299] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getAtomicRegex(), FEATURES[8]);
		LINKS[300] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getRegexReference(), FEATURES[8]);
		LINKS[301] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getTokenStyle(), FEATURES[4]);
		LINKS[302] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getAnnotation(), FEATURES[0]);
		LINKS[303] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getKeyValuePair(), FEATURES[9]);
		LINKS[304] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getKeyValuePair(), FEATURES[9]);
		LINKS[305] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getAnnotation(), FEATURES[0]);
		LINKS[306] = new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getAnnotation(), FEATURES[0]);
	}
	
	public static void initializeLinks() {
		initializeLinks0();
	}
	
	public static void wire0() {
		TERMINALS[1].addFollower(TERMINALS[2], EMPTY_LINK_ARRAY);
		TERMINALS[2].addFollower(TERMINALS[3], EMPTY_LINK_ARRAY);
		TERMINALS[3].addFollower(TERMINALS[4], EMPTY_LINK_ARRAY);
		TERMINALS[4].addFollower(TERMINALS[5], EMPTY_LINK_ARRAY);
		TERMINALS[5].addFollower(TERMINALS[6], EMPTY_LINK_ARRAY);
		TERMINALS[5].addFollower(TERMINALS[7], EMPTY_LINK_ARRAY);
		TERMINALS[5].addFollower(TERMINALS[8], EMPTY_LINK_ARRAY);
		TERMINALS[5].addFollower(TERMINALS[9], EMPTY_LINK_ARRAY);
		TERMINALS[5].addFollower(TERMINALS[10], EMPTY_LINK_ARRAY);
		TERMINALS[5].addFollower(TERMINALS[11], EMPTY_LINK_ARRAY);
		TERMINALS[5].addFollower(TERMINALS[12], EMPTY_LINK_ARRAY);
		TERMINALS[6].addFollower(TERMINALS[7], EMPTY_LINK_ARRAY);
		TERMINALS[6].addFollower(TERMINALS[8], EMPTY_LINK_ARRAY);
		TERMINALS[6].addFollower(TERMINALS[9], EMPTY_LINK_ARRAY);
		TERMINALS[6].addFollower(TERMINALS[10], EMPTY_LINK_ARRAY);
		TERMINALS[6].addFollower(TERMINALS[11], EMPTY_LINK_ARRAY);
		TERMINALS[6].addFollower(TERMINALS[12], EMPTY_LINK_ARRAY);
		TERMINALS[7].addFollower(TERMINALS[13], EMPTY_LINK_ARRAY);
		TERMINALS[13].addFollower(TERMINALS[14], EMPTY_LINK_ARRAY);
		TERMINALS[13].addFollower(TERMINALS[8], EMPTY_LINK_ARRAY);
		TERMINALS[13].addFollower(TERMINALS[9], EMPTY_LINK_ARRAY);
		TERMINALS[13].addFollower(TERMINALS[10], EMPTY_LINK_ARRAY);
		TERMINALS[13].addFollower(TERMINALS[11], EMPTY_LINK_ARRAY);
		TERMINALS[13].addFollower(TERMINALS[12], EMPTY_LINK_ARRAY);
		TERMINALS[14].addFollower(TERMINALS[15], EMPTY_LINK_ARRAY);
		TERMINALS[15].addFollower(TERMINALS[14], EMPTY_LINK_ARRAY);
		TERMINALS[15].addFollower(TERMINALS[8], EMPTY_LINK_ARRAY);
		TERMINALS[15].addFollower(TERMINALS[9], EMPTY_LINK_ARRAY);
		TERMINALS[15].addFollower(TERMINALS[10], EMPTY_LINK_ARRAY);
		TERMINALS[15].addFollower(TERMINALS[11], EMPTY_LINK_ARRAY);
		TERMINALS[15].addFollower(TERMINALS[12], EMPTY_LINK_ARRAY);
		TERMINALS[8].addFollower(TERMINALS[16], EMPTY_LINK_ARRAY);
		TERMINALS[16].addFollower(TERMINALS[0], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getAnnotation(), FEATURES[0]), new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getImport(), FEATURES[1]), });
		TERMINALS[16].addFollower(TERMINALS[17], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getImport(), FEATURES[1]), });
		TERMINALS[16].addFollower(TERMINALS[18], EMPTY_LINK_ARRAY);
		TERMINALS[18].addFollower(TERMINALS[9], EMPTY_LINK_ARRAY);
		TERMINALS[18].addFollower(TERMINALS[10], EMPTY_LINK_ARRAY);
		TERMINALS[18].addFollower(TERMINALS[11], EMPTY_LINK_ARRAY);
		TERMINALS[18].addFollower(TERMINALS[12], EMPTY_LINK_ARRAY);
		TERMINALS[9].addFollower(TERMINALS[19], EMPTY_LINK_ARRAY);
		TERMINALS[19].addFollower(TERMINALS[20], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getOption(), FEATURES[2]), });
		TERMINALS[19].addFollower(TERMINALS[21], EMPTY_LINK_ARRAY);
		TERMINALS[22].addFollower(TERMINALS[20], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getOption(), FEATURES[2]), });
		TERMINALS[22].addFollower(TERMINALS[21], EMPTY_LINK_ARRAY);
		TERMINALS[21].addFollower(TERMINALS[10], EMPTY_LINK_ARRAY);
		TERMINALS[21].addFollower(TERMINALS[11], EMPTY_LINK_ARRAY);
		TERMINALS[21].addFollower(TERMINALS[12], EMPTY_LINK_ARRAY);
		TERMINALS[10].addFollower(TERMINALS[23], EMPTY_LINK_ARRAY);
		TERMINALS[23].addFollower(TERMINALS[0], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getAnnotation(), FEATURES[0]), new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getTokenRedefinition(), FEATURES[3]), });
		TERMINALS[23].addFollower(TERMINALS[24], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getTokenRedefinition(), FEATURES[3]), });
		TERMINALS[23].addFollower(TERMINALS[25], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getNormalTokenDefinition(), FEATURES[3]), });
		TERMINALS[23].addFollower(TERMINALS[26], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getPartialTokenDefinition(), FEATURES[3]), });
		TERMINALS[23].addFollower(TERMINALS[27], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getTokenPriorityDirective(), FEATURES[3]), });
		TERMINALS[23].addFollower(TERMINALS[28], EMPTY_LINK_ARRAY);
		TERMINALS[29].addFollower(TERMINALS[0], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getAnnotation(), FEATURES[0]), new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getTokenRedefinition(), FEATURES[3]), });
		TERMINALS[29].addFollower(TERMINALS[24], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getTokenRedefinition(), FEATURES[3]), });
		TERMINALS[29].addFollower(TERMINALS[25], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getNormalTokenDefinition(), FEATURES[3]), });
		TERMINALS[29].addFollower(TERMINALS[26], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getPartialTokenDefinition(), FEATURES[3]), });
		TERMINALS[29].addFollower(TERMINALS[27], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getTokenPriorityDirective(), FEATURES[3]), });
		TERMINALS[29].addFollower(TERMINALS[28], EMPTY_LINK_ARRAY);
		TERMINALS[28].addFollower(TERMINALS[11], EMPTY_LINK_ARRAY);
		TERMINALS[28].addFollower(TERMINALS[12], EMPTY_LINK_ARRAY);
		TERMINALS[11].addFollower(TERMINALS[30], EMPTY_LINK_ARRAY);
		TERMINALS[30].addFollower(TERMINALS[31], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getTokenStyle(), FEATURES[4]), });
		TERMINALS[30].addFollower(TERMINALS[32], EMPTY_LINK_ARRAY);
		TERMINALS[32].addFollower(TERMINALS[12], EMPTY_LINK_ARRAY);
		TERMINALS[12].addFollower(TERMINALS[33], EMPTY_LINK_ARRAY);
		TERMINALS[33].addFollower(TERMINALS[0], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getAnnotation(), FEATURES[0]), new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getRule(), FEATURES[5]), });
		TERMINALS[33].addFollower(TERMINALS[34], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getRule(), FEATURES[5]), });
		TERMINALS[33].addFollower(TERMINALS[35], EMPTY_LINK_ARRAY);
		TERMINALS[17].addFollower(TERMINALS[36], EMPTY_LINK_ARRAY);
		TERMINALS[36].addFollower(TERMINALS[37], EMPTY_LINK_ARRAY);
		TERMINALS[37].addFollower(TERMINALS[38], EMPTY_LINK_ARRAY);
		TERMINALS[37].addFollower(TERMINALS[39], EMPTY_LINK_ARRAY);
		TERMINALS[37].addFollower(TERMINALS[0], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getAnnotation(), FEATURES[0]), new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getImport(), FEATURES[1]), });
		TERMINALS[37].addFollower(TERMINALS[17], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getImport(), FEATURES[1]), });
		TERMINALS[37].addFollower(TERMINALS[18], EMPTY_LINK_ARRAY);
		TERMINALS[38].addFollower(TERMINALS[39], EMPTY_LINK_ARRAY);
		TERMINALS[38].addFollower(TERMINALS[0], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getAnnotation(), FEATURES[0]), new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getImport(), FEATURES[1]), });
		TERMINALS[38].addFollower(TERMINALS[17], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getImport(), FEATURES[1]), });
		TERMINALS[38].addFollower(TERMINALS[18], EMPTY_LINK_ARRAY);
		TERMINALS[39].addFollower(TERMINALS[40], EMPTY_LINK_ARRAY);
		TERMINALS[40].addFollower(TERMINALS[41], EMPTY_LINK_ARRAY);
		TERMINALS[41].addFollower(TERMINALS[42], EMPTY_LINK_ARRAY);
		TERMINALS[41].addFollower(TERMINALS[0], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getAnnotation(), FEATURES[0]), new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getImport(), FEATURES[1]), });
		TERMINALS[41].addFollower(TERMINALS[17], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getImport(), FEATURES[1]), });
		TERMINALS[41].addFollower(TERMINALS[18], EMPTY_LINK_ARRAY);
		TERMINALS[42].addFollower(TERMINALS[0], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getAnnotation(), FEATURES[0]), new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getImport(), FEATURES[1]), });
		TERMINALS[42].addFollower(TERMINALS[17], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getImport(), FEATURES[1]), });
		TERMINALS[42].addFollower(TERMINALS[18], EMPTY_LINK_ARRAY);
		TERMINALS[20].addFollower(TERMINALS[43], EMPTY_LINK_ARRAY);
		TERMINALS[43].addFollower(TERMINALS[44], EMPTY_LINK_ARRAY);
		TERMINALS[44].addFollower(TERMINALS[22], EMPTY_LINK_ARRAY);
		TERMINALS[34].addFollower(TERMINALS[45], EMPTY_LINK_ARRAY);
		TERMINALS[45].addFollower(TERMINALS[46], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getCsString(), FEATURES[6]), new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getSequence(), FEATURES[6]), new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getChoice(), FEATURES[6]), });
		TERMINALS[45].addFollower(TERMINALS[47], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getPlaceholderUsingSpecifiedToken(), FEATURES[6]), new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getSequence(), FEATURES[6]), new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getChoice(), FEATURES[6]), });
		TERMINALS[45].addFollower(TERMINALS[48], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getPlaceholderUsingDefaultToken(), FEATURES[6]), new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getSequence(), FEATURES[6]), new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getChoice(), FEATURES[6]), });
		TERMINALS[45].addFollower(TERMINALS[49], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getPlaceholderInQuotes(), FEATURES[6]), new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getSequence(), FEATURES[6]), new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getChoice(), FEATURES[6]), });
		TERMINALS[45].addFollower(TERMINALS[50], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getBooleanTerminal(), FEATURES[6]), new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getSequence(), FEATURES[6]), new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getChoice(), FEATURES[6]), });
		TERMINALS[45].addFollower(TERMINALS[51], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getEnumTerminal(), FEATURES[6]), new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getSequence(), FEATURES[6]), new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getChoice(), FEATURES[6]), });
		TERMINALS[45].addFollower(TERMINALS[52], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getContainment(), FEATURES[6]), new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getSequence(), FEATURES[6]), new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getChoice(), FEATURES[6]), });
		TERMINALS[45].addFollower(TERMINALS[53], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getCompoundDefinition(), FEATURES[6]), new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getSequence(), FEATURES[6]), new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getChoice(), FEATURES[6]), });
		TERMINALS[45].addFollower(TERMINALS[54], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getWhiteSpaces(), FEATURES[6]), new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getSequence(), FEATURES[6]), new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getChoice(), FEATURES[6]), });
		TERMINALS[45].addFollower(TERMINALS[55], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getLineBreak(), FEATURES[6]), new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getSequence(), FEATURES[6]), new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getChoice(), FEATURES[6]), });
		TERMINALS[56].addFollower(TERMINALS[0], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getAnnotation(), FEATURES[0]), new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getRule(), FEATURES[5]), });
		TERMINALS[56].addFollower(TERMINALS[34], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getRule(), FEATURES[5]), });
		TERMINALS[56].addFollower(TERMINALS[35], EMPTY_LINK_ARRAY);
		TERMINALS[57].addFollower(TERMINALS[46], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getCsString(), FEATURES[6]), new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getSequence(), FEATURES[6]), });
		TERMINALS[57].addFollower(TERMINALS[47], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getPlaceholderUsingSpecifiedToken(), FEATURES[6]), new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getSequence(), FEATURES[6]), });
		TERMINALS[57].addFollower(TERMINALS[48], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getPlaceholderUsingDefaultToken(), FEATURES[6]), new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getSequence(), FEATURES[6]), });
		TERMINALS[57].addFollower(TERMINALS[49], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getPlaceholderInQuotes(), FEATURES[6]), new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getSequence(), FEATURES[6]), });
		TERMINALS[57].addFollower(TERMINALS[50], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getBooleanTerminal(), FEATURES[6]), new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getSequence(), FEATURES[6]), });
		TERMINALS[57].addFollower(TERMINALS[51], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getEnumTerminal(), FEATURES[6]), new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getSequence(), FEATURES[6]), });
		TERMINALS[57].addFollower(TERMINALS[52], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getContainment(), FEATURES[6]), new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getSequence(), FEATURES[6]), });
		TERMINALS[57].addFollower(TERMINALS[53], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getCompoundDefinition(), FEATURES[6]), new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getSequence(), FEATURES[6]), });
		TERMINALS[57].addFollower(TERMINALS[54], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getWhiteSpaces(), FEATURES[6]), new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getSequence(), FEATURES[6]), });
		TERMINALS[57].addFollower(TERMINALS[55], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getLineBreak(), FEATURES[6]), new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getSequence(), FEATURES[6]), });
		TERMINALS[46].addFollower(TERMINALS[46], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getCsString(), FEATURES[6]), });
		TERMINALS[46].addFollower(TERMINALS[47], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getPlaceholderUsingSpecifiedToken(), FEATURES[6]), });
		TERMINALS[46].addFollower(TERMINALS[48], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getPlaceholderUsingDefaultToken(), FEATURES[6]), });
		TERMINALS[46].addFollower(TERMINALS[49], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getPlaceholderInQuotes(), FEATURES[6]), });
		TERMINALS[46].addFollower(TERMINALS[50], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getBooleanTerminal(), FEATURES[6]), });
		TERMINALS[46].addFollower(TERMINALS[51], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getEnumTerminal(), FEATURES[6]), });
		TERMINALS[46].addFollower(TERMINALS[52], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getContainment(), FEATURES[6]), });
		TERMINALS[46].addFollower(TERMINALS[53], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getCompoundDefinition(), FEATURES[6]), });
		TERMINALS[46].addFollower(TERMINALS[54], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getWhiteSpaces(), FEATURES[6]), });
		TERMINALS[46].addFollower(TERMINALS[55], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getLineBreak(), FEATURES[6]), });
		TERMINALS[46].addFollower(TERMINALS[57], EMPTY_LINK_ARRAY);
		TERMINALS[46].addFollower(TERMINALS[56], EMPTY_LINK_ARRAY);
		TERMINALS[46].addFollower(TERMINALS[58], EMPTY_LINK_ARRAY);
		TERMINALS[47].addFollower(TERMINALS[59], EMPTY_LINK_ARRAY);
		TERMINALS[59].addFollower(TERMINALS[60], EMPTY_LINK_ARRAY);
		TERMINALS[60].addFollower(TERMINALS[61], EMPTY_LINK_ARRAY);
		TERMINALS[61].addFollower(TERMINALS[62], EMPTY_LINK_ARRAY);
		TERMINALS[48].addFollower(TERMINALS[63], EMPTY_LINK_ARRAY);
		TERMINALS[63].addFollower(TERMINALS[64], EMPTY_LINK_ARRAY);
		TERMINALS[64].addFollower(TERMINALS[65], EMPTY_LINK_ARRAY);
		TERMINALS[49].addFollower(TERMINALS[66], EMPTY_LINK_ARRAY);
		TERMINALS[66].addFollower(TERMINALS[67], EMPTY_LINK_ARRAY);
		TERMINALS[67].addFollower(TERMINALS[68], EMPTY_LINK_ARRAY);
		TERMINALS[68].addFollower(TERMINALS[69], EMPTY_LINK_ARRAY);
		TERMINALS[69].addFollower(TERMINALS[70], EMPTY_LINK_ARRAY);
		TERMINALS[69].addFollower(TERMINALS[71], EMPTY_LINK_ARRAY);
		TERMINALS[70].addFollower(TERMINALS[72], EMPTY_LINK_ARRAY);
		TERMINALS[72].addFollower(TERMINALS[71], EMPTY_LINK_ARRAY);
		TERMINALS[71].addFollower(TERMINALS[73], EMPTY_LINK_ARRAY);
		TERMINALS[50].addFollower(TERMINALS[74], EMPTY_LINK_ARRAY);
		TERMINALS[74].addFollower(TERMINALS[75], EMPTY_LINK_ARRAY);
		TERMINALS[75].addFollower(TERMINALS[76], EMPTY_LINK_ARRAY);
		TERMINALS[76].addFollower(TERMINALS[77], EMPTY_LINK_ARRAY);
		TERMINALS[77].addFollower(TERMINALS[78], EMPTY_LINK_ARRAY);
		TERMINALS[78].addFollower(TERMINALS[79], EMPTY_LINK_ARRAY);
		TERMINALS[51].addFollower(TERMINALS[80], EMPTY_LINK_ARRAY);
		TERMINALS[80].addFollower(TERMINALS[81], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getEnumLiteralTerminal(), FEATURES[7]), });
		TERMINALS[82].addFollower(TERMINALS[81], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getEnumLiteralTerminal(), FEATURES[7]), });
		TERMINALS[83].addFollower(TERMINALS[84], EMPTY_LINK_ARRAY);
		TERMINALS[81].addFollower(TERMINALS[85], EMPTY_LINK_ARRAY);
		TERMINALS[85].addFollower(TERMINALS[86], EMPTY_LINK_ARRAY);
		TERMINALS[86].addFollower(TERMINALS[82], EMPTY_LINK_ARRAY);
		TERMINALS[86].addFollower(TERMINALS[83], EMPTY_LINK_ARRAY);
		TERMINALS[52].addFollower(TERMINALS[87], EMPTY_LINK_ARRAY);
		TERMINALS[52].addFollower(TERMINALS[88], EMPTY_LINK_ARRAY);
		TERMINALS[87].addFollower(TERMINALS[89], EMPTY_LINK_ARRAY);
		TERMINALS[89].addFollower(TERMINALS[90], EMPTY_LINK_ARRAY);
		TERMINALS[89].addFollower(TERMINALS[88], EMPTY_LINK_ARRAY);
		TERMINALS[90].addFollower(TERMINALS[91], EMPTY_LINK_ARRAY);
		TERMINALS[91].addFollower(TERMINALS[90], EMPTY_LINK_ARRAY);
		TERMINALS[91].addFollower(TERMINALS[88], EMPTY_LINK_ARRAY);
		TERMINALS[53].addFollower(TERMINALS[46], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getCsString(), FEATURES[6]), new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getSequence(), FEATURES[6]), new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getChoice(), FEATURES[6]), });
		TERMINALS[53].addFollower(TERMINALS[47], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getPlaceholderUsingSpecifiedToken(), FEATURES[6]), new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getSequence(), FEATURES[6]), new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getChoice(), FEATURES[6]), });
		TERMINALS[53].addFollower(TERMINALS[48], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getPlaceholderUsingDefaultToken(), FEATURES[6]), new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getSequence(), FEATURES[6]), new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getChoice(), FEATURES[6]), });
		TERMINALS[53].addFollower(TERMINALS[49], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getPlaceholderInQuotes(), FEATURES[6]), new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getSequence(), FEATURES[6]), new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getChoice(), FEATURES[6]), });
		TERMINALS[53].addFollower(TERMINALS[50], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getBooleanTerminal(), FEATURES[6]), new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getSequence(), FEATURES[6]), new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getChoice(), FEATURES[6]), });
		TERMINALS[53].addFollower(TERMINALS[51], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getEnumTerminal(), FEATURES[6]), new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getSequence(), FEATURES[6]), new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getChoice(), FEATURES[6]), });
		TERMINALS[53].addFollower(TERMINALS[52], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getContainment(), FEATURES[6]), new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getSequence(), FEATURES[6]), new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getChoice(), FEATURES[6]), });
		TERMINALS[53].addFollower(TERMINALS[53], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getCompoundDefinition(), FEATURES[6]), new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getSequence(), FEATURES[6]), new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getChoice(), FEATURES[6]), });
		TERMINALS[53].addFollower(TERMINALS[54], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getWhiteSpaces(), FEATURES[6]), new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getSequence(), FEATURES[6]), new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getChoice(), FEATURES[6]), });
		TERMINALS[53].addFollower(TERMINALS[55], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getLineBreak(), FEATURES[6]), new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getSequence(), FEATURES[6]), new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getChoice(), FEATURES[6]), });
		TERMINALS[58].addFollower(TERMINALS[92], EMPTY_LINK_ARRAY);
		TERMINALS[54].addFollower(TERMINALS[46], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getCsString(), FEATURES[6]), });
		TERMINALS[54].addFollower(TERMINALS[47], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getPlaceholderUsingSpecifiedToken(), FEATURES[6]), });
		TERMINALS[54].addFollower(TERMINALS[48], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getPlaceholderUsingDefaultToken(), FEATURES[6]), });
		TERMINALS[54].addFollower(TERMINALS[49], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getPlaceholderInQuotes(), FEATURES[6]), });
		TERMINALS[54].addFollower(TERMINALS[50], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getBooleanTerminal(), FEATURES[6]), });
		TERMINALS[54].addFollower(TERMINALS[51], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getEnumTerminal(), FEATURES[6]), });
		TERMINALS[54].addFollower(TERMINALS[52], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getContainment(), FEATURES[6]), });
		TERMINALS[54].addFollower(TERMINALS[53], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getCompoundDefinition(), FEATURES[6]), });
		TERMINALS[54].addFollower(TERMINALS[54], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getWhiteSpaces(), FEATURES[6]), });
		TERMINALS[54].addFollower(TERMINALS[55], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getLineBreak(), FEATURES[6]), });
		TERMINALS[54].addFollower(TERMINALS[57], EMPTY_LINK_ARRAY);
		TERMINALS[54].addFollower(TERMINALS[56], EMPTY_LINK_ARRAY);
		TERMINALS[54].addFollower(TERMINALS[58], EMPTY_LINK_ARRAY);
		TERMINALS[55].addFollower(TERMINALS[46], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getCsString(), FEATURES[6]), });
		TERMINALS[55].addFollower(TERMINALS[47], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getPlaceholderUsingSpecifiedToken(), FEATURES[6]), });
		TERMINALS[55].addFollower(TERMINALS[48], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getPlaceholderUsingDefaultToken(), FEATURES[6]), });
		TERMINALS[55].addFollower(TERMINALS[49], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getPlaceholderInQuotes(), FEATURES[6]), });
		TERMINALS[55].addFollower(TERMINALS[50], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getBooleanTerminal(), FEATURES[6]), });
		TERMINALS[55].addFollower(TERMINALS[51], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getEnumTerminal(), FEATURES[6]), });
		TERMINALS[55].addFollower(TERMINALS[52], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getContainment(), FEATURES[6]), });
		TERMINALS[55].addFollower(TERMINALS[53], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getCompoundDefinition(), FEATURES[6]), });
		TERMINALS[55].addFollower(TERMINALS[54], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getWhiteSpaces(), FEATURES[6]), });
		TERMINALS[55].addFollower(TERMINALS[55], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getLineBreak(), FEATURES[6]), });
		TERMINALS[55].addFollower(TERMINALS[57], EMPTY_LINK_ARRAY);
		TERMINALS[55].addFollower(TERMINALS[56], EMPTY_LINK_ARRAY);
		TERMINALS[55].addFollower(TERMINALS[58], EMPTY_LINK_ARRAY);
		TERMINALS[24].addFollower(TERMINALS[93], EMPTY_LINK_ARRAY);
		TERMINALS[93].addFollower(TERMINALS[94], EMPTY_LINK_ARRAY);
		TERMINALS[94].addFollower(TERMINALS[95], EMPTY_LINK_ARRAY);
		TERMINALS[95].addFollower(TERMINALS[96], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getAtomicRegex(), FEATURES[8]), });
		TERMINALS[95].addFollower(TERMINALS[97], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getRegexReference(), FEATURES[8]), });
		TERMINALS[98].addFollower(TERMINALS[96], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getAtomicRegex(), FEATURES[8]), });
		TERMINALS[98].addFollower(TERMINALS[97], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getRegexReference(), FEATURES[8]), });
		TERMINALS[25].addFollower(TERMINALS[99], EMPTY_LINK_ARRAY);
		TERMINALS[99].addFollower(TERMINALS[96], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getAtomicRegex(), FEATURES[8]), });
		TERMINALS[99].addFollower(TERMINALS[97], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getRegexReference(), FEATURES[8]), });
		TERMINALS[100].addFollower(TERMINALS[96], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getAtomicRegex(), FEATURES[8]), });
		TERMINALS[100].addFollower(TERMINALS[97], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getRegexReference(), FEATURES[8]), });
		TERMINALS[101].addFollower(TERMINALS[102], EMPTY_LINK_ARRAY);
		TERMINALS[102].addFollower(TERMINALS[103], EMPTY_LINK_ARRAY);
		TERMINALS[103].addFollower(TERMINALS[29], EMPTY_LINK_ARRAY);
		TERMINALS[26].addFollower(TERMINALS[104], EMPTY_LINK_ARRAY);
		TERMINALS[104].addFollower(TERMINALS[105], EMPTY_LINK_ARRAY);
		TERMINALS[105].addFollower(TERMINALS[96], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getAtomicRegex(), FEATURES[8]), });
		TERMINALS[105].addFollower(TERMINALS[97], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getRegexReference(), FEATURES[8]), });
		TERMINALS[106].addFollower(TERMINALS[96], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getAtomicRegex(), FEATURES[8]), });
		TERMINALS[106].addFollower(TERMINALS[97], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getRegexReference(), FEATURES[8]), });
		TERMINALS[27].addFollower(TERMINALS[107], EMPTY_LINK_ARRAY);
		TERMINALS[107].addFollower(TERMINALS[29], EMPTY_LINK_ARRAY);
		TERMINALS[96].addFollower(TERMINALS[98], EMPTY_LINK_ARRAY);
		TERMINALS[96].addFollower(TERMINALS[29], EMPTY_LINK_ARRAY);
		TERMINALS[96].addFollower(TERMINALS[100], EMPTY_LINK_ARRAY);
		TERMINALS[96].addFollower(TERMINALS[101], EMPTY_LINK_ARRAY);
		TERMINALS[96].addFollower(TERMINALS[106], EMPTY_LINK_ARRAY);
		TERMINALS[97].addFollower(TERMINALS[98], EMPTY_LINK_ARRAY);
		TERMINALS[97].addFollower(TERMINALS[29], EMPTY_LINK_ARRAY);
		TERMINALS[97].addFollower(TERMINALS[100], EMPTY_LINK_ARRAY);
		TERMINALS[97].addFollower(TERMINALS[101], EMPTY_LINK_ARRAY);
		TERMINALS[97].addFollower(TERMINALS[106], EMPTY_LINK_ARRAY);
		TERMINALS[31].addFollower(TERMINALS[108], EMPTY_LINK_ARRAY);
		TERMINALS[31].addFollower(TERMINALS[109], EMPTY_LINK_ARRAY);
		TERMINALS[108].addFollower(TERMINALS[110], EMPTY_LINK_ARRAY);
		TERMINALS[110].addFollower(TERMINALS[108], EMPTY_LINK_ARRAY);
		TERMINALS[110].addFollower(TERMINALS[109], EMPTY_LINK_ARRAY);
		TERMINALS[109].addFollower(TERMINALS[111], EMPTY_LINK_ARRAY);
		TERMINALS[111].addFollower(TERMINALS[112], EMPTY_LINK_ARRAY);
		TERMINALS[111].addFollower(TERMINALS[113], EMPTY_LINK_ARRAY);
		TERMINALS[112].addFollower(TERMINALS[114], EMPTY_LINK_ARRAY);
		TERMINALS[114].addFollower(TERMINALS[112], EMPTY_LINK_ARRAY);
		TERMINALS[114].addFollower(TERMINALS[113], EMPTY_LINK_ARRAY);
		TERMINALS[113].addFollower(TERMINALS[31], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getTokenStyle(), FEATURES[4]), });
		TERMINALS[113].addFollower(TERMINALS[32], EMPTY_LINK_ARRAY);
		TERMINALS[0].addFollower(TERMINALS[115], EMPTY_LINK_ARRAY);
		TERMINALS[115].addFollower(TERMINALS[116], EMPTY_LINK_ARRAY);
		TERMINALS[115].addFollower(TERMINALS[0], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getAnnotation(), FEATURES[0]), });
		TERMINALS[115].addFollower(TERMINALS[1], EMPTY_LINK_ARRAY);
		TERMINALS[115].addFollower(TERMINALS[2], EMPTY_LINK_ARRAY);
		TERMINALS[115].addFollower(TERMINALS[17], EMPTY_LINK_ARRAY);
		TERMINALS[115].addFollower(TERMINALS[34], EMPTY_LINK_ARRAY);
		TERMINALS[115].addFollower(TERMINALS[24], EMPTY_LINK_ARRAY);
		TERMINALS[115].addFollower(TERMINALS[25], EMPTY_LINK_ARRAY);
		TERMINALS[116].addFollower(TERMINALS[117], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getKeyValuePair(), FEATURES[9]), });
		TERMINALS[118].addFollower(TERMINALS[117], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getKeyValuePair(), FEATURES[9]), });
		TERMINALS[119].addFollower(TERMINALS[0], new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature[] {new org.emftext.sdk.concretesyntax.resource.cs.mopp.CsContainedFeature(org.emftext.sdk.concretesyntax.ConcretesyntaxPackage.eINSTANCE.getAnnotation(), FEATURES[0]), });
		TERMINALS[119].addFollower(TERMINALS[1], EMPTY_LINK_ARRAY);
		TERMINALS[119].addFollower(TERMINALS[2], EMPTY_LINK_ARRAY);
		TERMINALS[119].addFollower(TERMINALS[17], EMPTY_LINK_ARRAY);
		TERMINALS[119].addFollower(TERMINALS[34], EMPTY_LINK_ARRAY);
		TERMINALS[119].addFollower(TERMINALS[24], EMPTY_LINK_ARRAY);
		TERMINALS[119].addFollower(TERMINALS[25], EMPTY_LINK_ARRAY);
		TERMINALS[117].addFollower(TERMINALS[120], EMPTY_LINK_ARRAY);
		TERMINALS[117].addFollower(TERMINALS[118], EMPTY_LINK_ARRAY);
		TERMINALS[117].addFollower(TERMINALS[119], EMPTY_LINK_ARRAY);
		TERMINALS[120].addFollower(TERMINALS[121], EMPTY_LINK_ARRAY);
		TERMINALS[121].addFollower(TERMINALS[118], EMPTY_LINK_ARRAY);
		TERMINALS[121].addFollower(TERMINALS[119], EMPTY_LINK_ARRAY);
	}
	
	public static void wire() {
		wire0();
	}
	
	static {
		// initialize the arrays
		initializeTerminals();
		initializeFeatures();
		initializeLinks();
		// wire the terminals
		wire();
	}
}
